// sintassi: nome_file

#include <windows.h>
#include <stdio.h>

DWORD RvaToOffset(IMAGE_NT_HEADERS *NT, DWORD Rva);

int main(int argc, char *argv[]) 
{
	HANDLE hFile;
	BYTE *BaseAddress;
	DWORD FileSize, BR, Res_Offset;

	IMAGE_DOS_HEADER *ImageDosHeader;
	IMAGE_NT_HEADERS *ImageNtHeaders;

	IMAGE_RESOURCE_DIRECTORY *ImgResDir;
	IMAGE_RESOURCE_DIRECTORY_ENTRY *ImgResDirEntry;

	DWORD ResDirs, x;

	IMAGE_RESOURCE_DIR_STRING_U *uString;
	char DlgName[100];

	BOOL bFound = FALSE;

	IMAGE_RESOURCE_DIRECTORY *ImgDlgsResDir;
	IMAGE_RESOURCE_DIRECTORY_ENTRY *ImgDlgsResDirEntry;

	DWORD Dlgs;

	IMAGE_RESOURCE_DIRECTORY *ImgDlgDir;
	IMAGE_RESOURCE_DIRECTORY_ENTRY *ImgDlgEntry;
	IMAGE_RESOURCE_DATA_ENTRY *ImgDlgDataEntry;


	// controlla numero argomenti
	if (argc < 2) 
	{
		printf("\nNeed More Arguments\n");
		return -1;
    }
 
	printf("\nOpening File...\n"); 

	hFile = CreateFile(argv[1], GENERIC_READ, FILE_SHARE_READ, 
		0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

	if (hFile == INVALID_HANDLE_VALUE) 
	{
		printf("Cannot Open the File\n");
		return -1;
	}

	FileSize = GetFileSize(hFile, NULL);

	BaseAddress = (BYTE *) malloc(FileSize);

	if (!ReadFile(hFile, BaseAddress, FileSize, &BR, NULL))
	{
		free(BaseAddress);
		CloseHandle(hFile);
		return -1;
	}
 
	ImageDosHeader = (IMAGE_DOS_HEADER *) BaseAddress;

	// controlliamo il Dos Header
	if (ImageDosHeader->e_magic != IMAGE_DOS_SIGNATURE)
	{
		printf("Invalid Dos Header\n");
		free(BaseAddress);
		CloseHandle(hFile);
		return -1;
	}

	ImageNtHeaders = (IMAGE_NT_HEADERS *) 
		(ImageDosHeader->e_lfanew + (DWORD) ImageDosHeader);

	// controlliamo il PE Header
	if (ImageNtHeaders->Signature != IMAGE_NT_SIGNATURE)
	{
		printf("Invalid PE Header\n");
		free(BaseAddress);
		CloseHandle(hFile);
		return -1;
	}  

	if (!ImageNtHeaders->OptionalHeader.DataDirectory
		[IMAGE_DIRECTORY_ENTRY_RESOURCE].VirtualAddress)
	{
		printf("This PE Doesn't Contain Resources\n");
		free(BaseAddress);
		CloseHandle(hFile);
		return -1;
	} 

	// converte in offset fisico l'RVA
	Res_Offset = RvaToOffset(ImageNtHeaders, 
		ImageNtHeaders->OptionalHeader.DataDirectory
		[IMAGE_DIRECTORY_ENTRY_RESOURCE].VirtualAddress);

	//  valido?
	if (Res_Offset == NULL)
	{
		printf("This PE Doesn't Contain Resources\n");
		free(BaseAddress);
		CloseHandle(hFile);
		return -1;
	}  

	// ricavo la Resource Dir
	ImgResDir = (IMAGE_RESOURCE_DIRECTORY *)(DWORD)
		(Res_Offset + (DWORD) BaseAddress);

	// ricavo il numero delle Resource Dirs
	ResDirs = ImgResDir->NumberOfIdEntries +  
		ImgResDir->NumberOfNamedEntries;

	printf("\nNumber of Resource Directories: %d\n", ResDirs);

	// ricavo il puntatore alle Res Dirs
	ImgResDirEntry = (IMAGE_RESOURCE_DIRECTORY_ENTRY *)
		(DWORD) (sizeof (IMAGE_RESOURCE_DIRECTORY) + (DWORD) ImgResDir);

	printf("\nDialogs:\n\n");

	// trovo la Res Dir per le dialogs
	for (x = 0; x < ResDirs; x++)
	{
		if (ImgResDirEntry[x].NameIsString == FALSE &&
			ImgResDirEntry[x].Id == 5)
		{
			bFound = TRUE;
			break;
		}
	}

	// non esiste?
	if (bFound == FALSE)
	{
		printf("This PE Doesn't contain a Dialogs Dir\n");
		free(BaseAddress);
		CloseHandle(hFile);
		return -1;
	}  

	// tanto mi serve solo questa Entry per le Dlgs
	ImgResDirEntry = (IMAGE_RESOURCE_DIRECTORY_ENTRY *)
		(DWORD) &ImgResDirEntry[x];

	// ci dovr pur essere una Res Dir per le dlgs
	if (ImgResDirEntry->DataIsDirectory == TRUE)
	{
		ImgDlgsResDir = (IMAGE_RESOURCE_DIRECTORY *)(DWORD)
			(ImgResDirEntry->OffsetToDirectory + 
			(DWORD) ImgResDir);

		// sommo le dlgs con nome a quelle senza
		// e ottengo il totale
		Dlgs = ImgDlgsResDir->NumberOfNamedEntries +
			ImgDlgsResDir->NumberOfIdEntries;

		printf("\nNumber of Dialogs: %d\n", Dlgs);

		// prendo l'array di dlgs
		ImgDlgsResDirEntry = (IMAGE_RESOURCE_DIRECTORY_ENTRY *)
			(DWORD) (sizeof (IMAGE_RESOURCE_DIRECTORY) + 
			(DWORD) ImgDlgsResDir);

		// elenco tutte le dlgs
		for (x = 0; x < Dlgs; x++)
		{
			printf("\nDialog %d", (x + 1)); 
			// la dlg ha nome?
			if (ImgDlgsResDirEntry[x].NameIsString == TRUE)
			{
				uString = (IMAGE_RESOURCE_DIR_STRING_U *)
					(DWORD) (ImgDlgsResDirEntry[x].NameOffset +
					(DWORD) ImgResDir);

				ZeroMemory(DlgName, sizeof(DlgName));

				// converto la stringa unicode
				WideCharToMultiByte(CP_ACP, NULL, 
					(LPCWSTR) &uString->NameString, uString->Length, 
					DlgName, sizeof (DlgName), NULL, NULL); 

				// stampa il nome
				printf(" Name: %s\n", DlgName);
			}
			else
			{
				// stampa l'ID
				printf(" ID: %d\n", ImgDlgsResDirEntry[x].Id);
			}


			// be'  sempre uguale
			// devo ricavare la res dir per la dlg
			if (ImgDlgsResDirEntry[x].DataIsDirectory == TRUE)
			{
				ImgDlgDir = (IMAGE_RESOURCE_DIRECTORY *)
					(DWORD) (ImgDlgsResDirEntry[x].OffsetToDirectory +
					(DWORD) ImgResDir);

				ImgDlgEntry = (IMAGE_RESOURCE_DIRECTORY_ENTRY *)
					(DWORD) (sizeof (IMAGE_RESOURCE_DIRECTORY)  +
					(DWORD) ImgDlgDir);

				// finalmente arrivo alla Data Entry
				ImgDlgDataEntry = (IMAGE_RESOURCE_DATA_ENTRY *)
					(DWORD) (ImgDlgEntry->OffsetToData +
					(DWORD) ImgResDir);

				// stampe le info riguardanti la dlg
				// ometto offset e reserved che sono
				// inutili a titolo di Info
				printf("Size: %d bytes - Code Page: %d\n", 
					ImgDlgDataEntry->Size, ImgDlgDataEntry->CodePage);

			}
		}
	}
	
	free(BaseAddress);
	CloseHandle(hFile);

	return 0;
}

// sappiamo a cosa serve

DWORD RvaToOffset(IMAGE_NT_HEADERS *NT, DWORD Rva)
{
	DWORD Offset = Rva, Limit;
	IMAGE_SECTION_HEADER *Img;
	WORD i;

	Img = IMAGE_FIRST_SECTION(NT);

	if (Rva < Img->PointerToRawData)
		return Rva;

	for (i = 0; i < NT->FileHeader.NumberOfSections; i++)
	{
		if (Img[i].SizeOfRawData)
			Limit = Img[i].SizeOfRawData;
		else
			Limit = Img[i].Misc.VirtualSize;

		if (Rva >= Img[i].VirtualAddress &&
		    Rva < (Img[i].VirtualAddress + Limit))
		{
			if (Img[i].PointerToRawData != 0)
			{
				Offset -= Img[i].VirtualAddress;
				Offset += Img[i].PointerToRawData;
			}
				
			return Offset;
		}
	}

	return NULL;
}